/* 
 




*/
#include <avr/io.h>
#include <avr\interrupt.h>	
#include <avr/pgmspace.h>
#include <util/delay.h>
#include <stdlib.h>	
#include <user_disp.h>
/*
#define BIT(bit)  (1<<(bit))
#define SetBit(Port,bit) Port |= ( 0x01 << bit )
#define ClrBit(Port,bit) Port &= ( ~( 0x01 << bit ) )
*/

#define SetBit(Port,bit) Port |= _BV(bit)
#define ClrBit(Port,bit) Port &= ~_BV(bit)


// 
//#define BUTTON_IN_CD (PINB & 0x04)
//#define BUTTON_IN_PC (PINB & 0x08)
//#define BUTTON_IN_AU (PINB & 0x10)
//#define BUTTON_MUTE  (PINB & 0x02)
//#define BUTTON_POWER  (PINB & 0x20)

//#define BUTTON_SUM	(BUTTON_IN_CD && BUTTON_IN_PC && BUTTON_IN_AU && BUTTON_MUTE && BUTTON_SET && BUTTON_POWER )


/*
// 
#define ALARM_L (PINB & 0x40)
#define ALARM_R (PINB & 0x80)
*/
// RELE 
#define SHIFT_ON SetBit(PORTC,2)
#define SHIFT_OFF ClrBit(PORTC,2)
#define DATA_ON SetBit(PORTC,0)
#define DATA_OFF ClrBit(PORTC,0)
#define STORAGE_ON SetBit(PORTC,1)
#define STORAGE_OFF ClrBit(PORTC,1)

//   pusc1
#define RELE1_ON SetBit(PORTC,3)
#define RELE1_OFF ClrBit(PORTC,3)

//   pusc2
#define RELE2_ON SetBit(PORTC,4)
#define RELE2_OFF ClrBit(PORTC,4)

// MUTE
#define PIN_MUTE_ON SetBit(PORTC,5)
#define PIN_MUTE_OFF ClrBit(PORTC,5)


//  /
#define LED_SLEEP SetBit(PORTD,4)
#define LED_SLEEP_OFF ClrBit(PORTD,4)




//  
#define INIT_DDRB 0xC1
#define INIT_DDRC 0xFF
#define INIT_DDRD 0xF0

#define VALUE_PORTB 0x3E
#define VALUE_PORTC 0x0
#define VALUE_PORTD 0x0F

// 

//----------- --------------
#define T_TIM_CLICK _BV(0)			//  
#define TF_TIM_CLICK (t_flag&0x01)

#define T_R_SLEEP _BV(1)		//t    
#define TF_R_SLEEP (t_flag&0x02)

#define T_NO_CLIC _BV(2)		//   (   ,   2mc  )
#define TF_NO_CLIC (t_flag&0x04)

#define T_PRESS _BV(3)			//   ,     
#define TF_PRESS (t_flag&0x08)

#define T_ADRG _BV(4)			//
#define TF_ADRG (t_flag&0x10)

#define T_SW_BUT _BV(5)			// 
#define TF_SW_BUT (t_flag&0x20)

#define T_FIELD _BV(6)			// 
#define TF_FIELD (t_flag&0x40)

#define T_BLINK _BV(7)			// 
#define TF_BLINK (t_flag&0x80)



//----------------------------------
#define BUTTON_SET  (PIND & 0x01)
#define PIN_ENCODER   (PIND & 0x04)
#define PIN_ENCODER2  (PIND & 0x02)

#define B_PLUS _BV(0)
#define BF_PLUS (b_flag&0x01)

#define B_MINUS _BV(1)
#define BF_MINUS (b_flag&0x02)

#define B_DISP _BV(2)
#define BF_DISP (b_flag&0x04)

//#define B_MUTE _BV(3)
//#define BF_MUTE (b_flag&0x08)

#define B_SET _BV(4)
#define BF_SET (b_flag&0x10)

#define B_INPUT _BV(5)
#define BF_INPUT (b_flag&0x20)

#define B_LONG _BV(6)
#define BF_LONG (b_flag&0x40)

#define B_DB_CLICK _BV(7)
#define BF_DB_CLICK (b_flag&0x80)
//----------------end----------------------


// RC5_T-    ,   1,778mSek
#define		RC5_T			1778
#define		FAULT_TIME_RC5	RC5_T*17
#define 	TOLERANCE		(RC5_T/10)	//  10%	

#define		FL_RC5_RESET	_BV(0)	//  
#define		FL_STBIT_1		_BV(1)	//   
#define	 	FL_SAMPLE		_BV(7)	//  
#define	 	FL_FAULT		_BV(2)	//  
//----------------end----------------------

#define T_B_ANDR 25//25	// 	0.1c		input|mute|disp	
#define T_BUTTON 180//	//  	0.36c 	(t_blink_count+1)!!! input|mute|disp
#define T_OFF_RELAY	50	//     1=0,002
#define T_SUBPROG 40		//20c     1=0,5cek
#define T_OCNREG 4	
#define T_MUT_DELAY 50	// /   1=0.002c
//---------------------------------end----------------------------------------------


uint8_t t_adrg_count; //!!!
uint8_t adrg_click;
volatile uint8_t t_flag;		// _  (T_SWITCH|T_NO_CLIC|T_R_SLEEP|T_PRESS|T_ADRG) 
uint8_t b_flag;					// 

uint8_t begin_vol;
uint8_t start_volume;
uint8_t start_mode;

uint8_t current_vol;
uint8_t old_vol;

uint8_t rc5_ok;

uint8_t eep_z;

//------------ENCODER-----------------------------
#define		EN_INPUT		_BV(0)	// 
#define	 	EN_PLUS			_BV(1)	// 
#define	 	EN_MINUS		_BV(2)	// 
#define 	ENF_INPUT		(enc_flag&0x01)
#define 	ENF_PLUS		(enc_flag&0x04)
#define 	ENF_MINUS		(enc_flag&0x08)


uint8_t enc_input;//
uint8_t step_encoder_vol;
uint8_t step_encoder_menu;
uint8_t step_enc_upr;
uint8_t adrg_encoder;
uint8_t pl, ms;
uint8_t enc_flag;
//-----------ENCODER END----------------------------

uint8_t ur;
uint8_t N_input;				//  PC  Cd
uint8_t lg;						//
uint8_t vizualD;				//    
uint8_t k_usil;					//  
uint8_t mute;
volatile uint8_t t_menu;
uint8_t regim;					//    1
uint8_t duration_press;			// 

uint8_t t_blink_count;
uint8_t pusk;					//    
uint8_t pusk2;
//uint8_t r_sleep;


uint8_t kom_plus;
uint8_t kom_minus;
uint8_t kom_input;
uint8_t kom_input1;
uint8_t kom_input2;
uint8_t kom_mute;
uint8_t kom_set;
uint8_t kom_menu;
uint8_t kom_power;
//uint8_t kom_7;
uint8_t syst;

uint8_t upr=100;

typedef struct struct_rc5{
	uint16_t data;
	uint8_t upr_bit;
	uint8_t system;	// ,   ..
	uint8_t komanda;	// ,    ->  
	uint8_t flag;
	uint8_t data_ok;
	uint8_t error;
	
	
} struct_rc5;

struct_rc5 rc5;




//-----------------------------------------------------------------------------------


prog_uint8_t player		[32]={66,120,111,227,58,32,32,32,67,224,32,190,187,101,101,112, //:  
							73,110,112,117,116,58,32,67,68,32,80,108,97,121,101,114};
prog_uint8_t comp     	[32]={66,120,111,227,58,32,32,75,111,188,190,196,198,191,101,112,//: 
							73,110,112,117,116,58,32,32,67,111,109,112,117,116,101,114};
prog_int8_t tuner     	[32]={32,66,120,111,227,58,32,32,32,32,32,'A','U','X',32,32,//: 
							32,73,110,112,117,116,58,32,32,32,32,'A','U','X',32,32};
							
uint8_t v_level			[16]={0,':',95,95,95,95,95,95,95,95,95,95,95,95,'d','B'}; // :____________00

prog_int8_t d_set_1		[16]={32,32,32,32,32,83,101,116,117,112,32,32,32,32,32,32};


prog_uint8_t d_rc5_1		[32]={189,97,99,191,112,111,185,186,97,32,186,189,111,190,111,186,// 
								115,101,116,117,112,32,32,111,102,32,98,117,116,116,111,110};//adjustment of
prog_uint8_t d_rc5_2		[32]={32,32,190,121,187,196,191,97,32,40,82,67,53,41,32,32,// (RC5)
								32,32,114,101,109,111,116,101,32,40,82,67,53,41,32,32}; //  remote (RC5)  
uint8_t rcbut []={112,108,117,115,32,109,105,110,117,115,105,110,46,67,68,105,110,46,80,67,105,46,65,85,88,109,117,116,
					101,32,32,115,101,116,32,109,101,110,117,32,112,111,119,101,114}; //"plus minusin.CDin.PCii.AUXtmute set menu power"
uint8_t d_rc5_but	[16]={32,32,32,32,32,58,32,115,46,95,95,32,107,46,95,95};//{32,32,32,32,32,32,32,32,32,32,40,32,32,41,32,32,0};	//.........(   ).. 


prog_uint8_t gain_db_1	[32]={32,186,111,197,228,46,32,121,99,184,187,101,189,184,199,32,
						99,111,101,102,102,105,99,105,101,110,116,32,103,97,105,110};//.  
uint8_t gain_db_2	[32]={121,99,184,187,184,191,101,187,199,32,45,32,50,48,100,'B',
						97,109,112,108,105,102,105,101,114,32,45,32,32,32,100,'B'};// (db)  



prog_uint8_t language	[32]={32,32,66,195,178,112,97,191,196,32,199,183,195,186,32,32,	// 
							83,101,108,101,99,116,32,32,108,97,110,103,117,97,103,101};
uint8_t language1	[32]={32,32,32,32,112,121,99,99,186,184,185,32,32,32,32,32,	//
							32,32,32,32,101,110,103,108,105,115,104,32,32,32,32,32};	//


prog_uint8_t rele		[32]={32,164,97,227,101,112,182,186,97,32,32,179,186,187,46,32,// 
							32,84,105,109,101,32,100,101,108,97,121,32,111,110,32,32};
uint8_t rele2		[32]={112,101,187,46,190,184,191,97,189,184,199,32,48,44,48,99,//112,101,187,101,32,190,184,191,97,189,184,199,32,49,32,99,0,
							112,111,119,101,114,32,114,101,108,97,121,32,49,44,54,99};//112,111,119,101,114,32,114,101,108,97,121,58,32,49,32,99,0};//. 
uint8_t rele3		[32]={112,187,46,97,186,121,99,191,184,186,184,32,48,46,48,99,// ". 0.0"{97,186,121,99,191,184,186,184,32,32,32,32,32,44,32,99,0,//"     , "
							97,99,111,117,115,116,105,99,115,32,32,32,32,44,32,99};//"acoustics    , c"


prog_uint8_t d_power	[32]={32,168,184,191,97,189,184,101,32,32,111,191,186,187,46,32,
							32,32,32,80,111,119,101,114,32,32,79,102,102,32,32,32};

uint8_t sfst[]={83,70,58,32,32,32,32,32,32,32,32,32,32,32,32,32};

prog_uint8_t vl_start []={32,180,112,111,188,186,111,99,191,196,32,190,112,184,32,32,//"    "
							32,32,76,111,117,100,110,101,115,115,32,97,116,32,32,32};//"  Loudness at   "
uint8_t vl_start2 []={179,186,187,198,192,101,189,184,184,32,32,45,49,48,100,66,//" - 10dB"
							105,110,99,108,117,115,105,111,110,32,32,45,49,48,100,66};//"inclusion - 10dB"

prog_uint8_t step_enc []={32,172,97,180,32,32,197,189,186,111,227,101,112,97,32,32,//"     "
							32,32,83,116,101,112,32,101,110,99,111,100,101,114,32,32};//"  Step encoder  "

uint8_t step_vol []={190,112,184,32,112,101,180,46,180,112,111,188,186,46,32,32,//" ..  "
						97,100,106,117,115,116,109,101,110,116,32,118,111,108,'.',32};//"adjustment vol: "
	
uint8_t step_menu []={190,112,184,32,112,101,180,46,32,188,101,189,198,':',32,32,//" .    "
						97,100,106,117,115,116,109,46,32,109,101,110,117,58,32,32};//"adjustm. menu:  "
//						111,100,101,114,32,97,100,106,46,109,101,110,117,58,32,32,0};//"oder adj.menu:  "

prog_uint8_t anti_enc		[]={179,112,46,32,97,189,191,184,227,112,101,178,101,183,180,97,//". "
								115,116,97,98,46,32,116,105,109,101,32,99,111,110,116,46};//"stab. time cont."
uint8_t anti_value 		[]={197,189,186,111,227,101,112,97,':',32,'0',',',46,'m','s','.',		//"  - 2mc." "
								101,110,99,111,100,101,114,32,45,32,'0',',',44,'m','s','.'};//"encoder -     mc"

prog_uint8_t soft_d []={32,32,32,83,111,102,116,32,115,116,97,114,116,32,32,32};//"   Soft start   "

uint8_t anti_clic			[32]={112,101,187,32,180,112,111,188,186,58,32,95,44,95,109,115, // : _,_ms
								114,101,108,97,121,32,118,111,108,58,32,32,',',32,109,115}; //relay vol:    ms

uint8_t vl_mod1 []={32,183,97,190,111,188,184,189,97,191,196,32,190,112,184,32,//"   "
						32,83,116,97,114,116,32,119,105,116,104,32,116,104,101,32};//" Start with the "

uint8_t vl_mod2 []={179,195,186,187,46,32,180,112,111,188,186,58,32,227,97,32,//". :  ""
						112,114,101,118,105,111,117,115,32,118,111,108,46,32,32,32};//"previous vol.   "


//-------------  ------------------
extern void 		lcd_4bus_write(uint8_t data);//   4  ,   RS=RW=0,  DB3..0 = 0    Z   
extern void 		lcd_write_data(uint8_t data);//write data to CGRAM or DDRAM
extern void 		lcd_instructions_set(uint8_t address);
extern void 		lcd_init(void);
extern void		lcd_set_address(uint8_t x, uint8_t y);

void out_rele (uint8_t data);
static void soft_start (void);
void keyboard (void);
void RC5 (void);
void sleep (void);
static void process_encoder (void);


void lcd_wr_str(uint8_t *str) {for(uint8_t i=0;i<16;i++) lcd_write_data(*str++);}
void lcd_puts_p(prog_int8_t *progmem_s )//     
{   uint8_t c;
	for(uint8_t i=0;i<16;i++) {
		c = pgm_read_byte(progmem_s++);
		lcd_write_data(c);
	}
}


uint16_t vlmas (prog_int8_t *progmem_s )
{	uint16_t b;
	b=pgm_read_word_near(progmem_s);
	return b;
}


void load_user_simvol(uint8_t adress, const uint8_t *progmem_str ){
	lcd_instructions_set(adress|0x40);//lcd_instructions_set(adress|SET_CGRAM_ADDRESS);
	for(uint8_t i=0; i<8; i++){lcd_write_data(pgm_read_byte(progmem_str++));}
}

//-------------Interupt------------------------

ISR(PCINT0_vect){
	if(regim!=10){
		if(regim) t_menu=T_SUBPROG;
		else t_menu=T_OCNREG;
	}
}

ISR(PCINT2_vect){
	if(regim!=10){
		if(regim) t_menu=T_SUBPROG;
		else t_menu=T_OCNREG;
	}
}



ISR(TIMER0_OVF_vect){//   / 0 (0,26112)*39=10,2
if(!(--ur)) {if(t_menu) t_menu--; ur=31;}
}


void plus_v (uint8_t napr){
	//static uint8_t pl=0,ms=0;
	uint8_t step;
	if(!step_enc_upr) step=step_encoder_vol;
		else step=step_encoder_menu;
//	PORTC^=_BV(4);
	if(napr){
		pl++;
		if(pl>step){enc_flag=1; pl=0;ms=0;	}
	}
	
	else{
		ms++;
		if(ms>step){enc_flag=2; ms=0;pl=0;}
	}
	
}

static void process_encoder (void){

	if(PIN_ENCODER){
		if(!PIN_ENCODER2) plus_v(1);//plus
		else plus_v(0);				//minus
		EICRA &=~_BV(ISC00);//    -  
	}
	
	else {
		if(PIN_ENCODER2) plus_v(1);
		else plus_v(0);
		EICRA |=_BV(ISC00);
	}
	enc_input=0;
	
}

ISR(INT0_vect){				//  encoder
	EIMSK = _BV(INT1);
	enc_input=1;
	TCNT2=251-(adrg_encoder*13);//19 .05ms=6.35
	if(!regim) t_menu=T_OCNREG;
}





ISR(TIMER2_COMPA_vect)	//  / 2
{	if (t_adrg_count){ if (--t_adrg_count==0)  t_flag&=~T_ADRG;}	
	
	//  
	t_blink_count++;			//  
	if (t_blink_count == 181) {  t_flag|=T_BLINK; t_blink_count=0;}//30
	
	static uint8_t t_time_click=255;			// 
	if(TF_TIM_CLICK){
		if (--t_time_click==0)  {t_flag&=~T_TIM_CLICK;t_time_click=180;}	
	}
	
	if(enc_input==1){process_encoder();EIFR|=_BV(INTF0);EIMSK = _BV(INT0)|_BV(INT1);}
	
}//-------------------RC5------------------------------------



ISR(INT1_vect){//    
static uint16_t period, receive;
static uint8_t counter_bit;
uint16_t capture;
	capture=TCNT1;
	
	if ( rc5.flag & FL_SAMPLE ){
		if ( (capture > period-TOLERANCE)&&(capture < period+TOLERANCE) )//   (  capture  )
			{
				TCNT1=0;
				receive<<=1;	
				if ( (EICRA & _BV(ISC10))==0 ) receive|=1;
				
				if (++counter_bit==12) 
				{	rc5.data=receive;
					rc5.system=(rc5.data&0b011111000000)>>6;
					rc5.komanda=rc5.data&0b111111;
					rc5.upr_bit=(rc5.data&0b100000000000)>>11;
					rc5.data_ok=1;
					rc5.flag &= ~FL_FAULT;
				}
			}
			EICRA ^=_BV(ISC10);	// _BV(ICS10)|_BV(ICS11);   &=~_BV(ICS10)
		}
	else
	if ( (rc5.flag & FL_STBIT_1)==0 ){// 
		OCR1A=FAULT_TIME_RC5;
		TCNT1=0;
		rc5.flag = FL_STBIT_1|FL_RC5_RESET; 
		}
	else
	if ( rc5.flag & FL_STBIT_1 ){//  
		period=capture;
		if (( period > RC5_T-TOLERANCE )&&( period < RC5_T+TOLERANCE ))
			{
			TCNT1=0;
			rc5.flag = FL_SAMPLE|FL_RC5_RESET;//|FL_FAULT;
			receive=counter_bit=0; 
			EICRA |=_BV(ISC10);//  
			}
		}
	
	if(regim!=10){
		if(regim) t_menu=T_SUBPROG;
		else t_menu=T_OCNREG;
	}
	
	SMCR &=~(1<<SE);		//off sleep

//	if (PIND & 0x08) {EICRA &=~_BV(ISC11);}	//    
//		else  {EICRA |=_BV(ISC11);}					//  
	
}

ISR (TIMER1_COMPA_vect){
	if ( rc5.flag & FL_RC5_RESET ){
	//	if ( rc5.flag & FL_FAULT ) rc5.error++;
		rc5.flag = 0;
		EICRA &=~_BV(ISC10);
	}
} 
//-------------------RC5------------------------------------







//-----------------EEPROM-----------------------
static inline unsigned char EEPROM_READ(unsigned int uiAddress)
{	while(EECR & (1<<EEPE));	//     
	EEAR = uiAddress;			//    
	EECR |= (1<<EERE);			//       EERE
	return EEDR;				//      
}

void EEPROM_write(unsigned int uiAddress, unsigned char ucData)
{	if ( EEPROM_READ(uiAddress)!=ucData)
	{	while(EECR & (1<<EEPE));	//     
		cli();						//     
		EEAR = uiAddress;
		EEDR = ucData;
		EECR |= (1<<EEMPE);		//  . 1   EEMPE 
		EECR |= (1<<EEPE);			//       EEPE 
		sei();
	}
}
//------------------end-------------------------



//------------------------------------
static void antidrebezg (uint8_t count)
{	t_adrg_count=count; t_flag|=T_ADRG; }





//--------   ------------
void lcd_blink (uint8_t *mass, uint8_t digit1, uint8_t amount)//, uint8_t stroka_lcd)		//2%
{	//digit1-    
	//amount--    
	uint8_t i;
	
	if (TF_BLINK){
		if (!TF_FIELD){
			lcd_set_address(0,1);	//  
			lcd_wr_str(mass);//t_flag|=T_FIELD;
		}
		else{
			for(i=0; i<amount ; i++){	// 
				lcd_set_address(digit1+i,1);
				lcd_write_data(' ');
			}//t_flag&=~T_FIELD;
		}
		t_flag&=~T_BLINK;t_flag^=T_FIELD;
	}
}


void itoa2(int8_t Value, uint8_t * buf, uint8_t mesto){
	uint8_t step[2]={10,1};
	uint8_t Subtract, Dig, i,i_;
	i=Value;
	for (i_=0; i_<2; i_++){
		Subtract=step[i_];
		Dig='0';
		while(i >= Subtract){
			Dig++;
			i-=Subtract;
		}
		buf[i_+mesto]=Dig;
	}
} 




void disp_update (void)	//timer=6.2ms
{	unsigned char voltmp, usil, i;
	
	//PORTC^=_BV(2);PORTC^=_BV(2);
	lcd_set_address(0,0);		
	lcd_set_address(0,0);		
	if (N_input==0) lcd_puts_p( (prog_int8_t *)&tuner[lg] );		//Cd
		else if(N_input==1) lcd_puts_p( (prog_int8_t *)&comp[lg] );			//Pc
			else lcd_puts_p( (prog_int8_t *)&player[lg] );
	
	for(i=2;i<14;i++) v_level[i]=' ';
	v_level [11]='-';
	for(i=0;i<7;i++) v_level[3+i]=1;
	if(current_vol>4) v_level[3]='_';
	for(i=0;i<6;i++) {if(current_vol>((i+2)*4)) v_level[4+i]=2+i;}
	if(mute) v_level[2]='*';
	//----------------- ------------------
	if (!vizualD){											
		if (current_vol == 62) v_level [11]=' '; 			//  
		voltmp = 62-current_vol*2;
		
	
	}
	//----------    ------
	else{
		usil = 31 - k_usil;
		voltmp = current_vol;
		if ( current_vol > usil ) {v_level [11]='+'; voltmp -= usil;}
			else {	voltmp = 31-current_vol; voltmp -= k_usil;}
		voltmp*=2;
		if (current_vol==usil) {v_level[11]=' ';}
	}
	
	itoa2(voltmp,v_level,12);
	//-------- --------------
	lcd_set_address(0,1);
	lcd_wr_str(v_level);//timer=2.48ms
}




void out_rele (uint8_t data)//,uint8_t off)
{	SHIFT_OFF;
	unsigned char i=0;
	for(i=0; i<8 ; i++)
	{  if (data & 1) DATA_ON;   //   
        else   DATA_OFF;
		data>>=1;
		SHIFT_ON;
		SHIFT_OFF;
	}
	STORAGE_ON;
	STORAGE_OFF;

}

void out_volume (uint8_t mut)
{	uint8_t buf,vol;
	
	PIN_MUTE_OFF;
	if(mute) {mute=0;old_vol=64;PIN_MUTE_OFF;}
	
	if(mut){
		buf=0;
		vol=0;
		mute=1;
	}
	else {
		buf=current_vol&old_vol;
		buf=buf<<2;
		vol=current_vol<<2;
	}
	
	if(N_input==1) {buf|=_BV(1);vol|=_BV(1);}
	if(N_input==2) {buf|=_BV(0);vol|=_BV(0);}
	
	
	TIMSK0 &= ~_BV(TOIE0);

	out_rele(buf);
	for (uint8_t i=0;i<adrg_click;i++) {//
		_delay_us(200);
	}
	out_rele(vol);

	old_vol=current_vol;

	TIMSK0 |= _BV(TOIE0);
	t_menu=T_OCNREG;
	disp_update();
	
	if(mut){
		antidrebezg (T_MUT_DELAY); 
		while (TF_ADRG);
		PIN_MUTE_ON;
	}
}




//*********************SETUP**************************

void cbr_b (void){
	b_flag=0;
	t_flag&=~T_BLINK;
	t_blink_count=0;

}


//------------  ----( -  )----------
unsigned char plus_minus (unsigned char count,unsigned char c){
	
	if (BF_PLUS){							//plus
		if ( count >= c) count = 0;
		else count++;
		cbr_b();
	}

	if (BF_MINUS){							//minus		
		if ( count != 0) count--;
		else count = c;
		cbr_b();
	}

	return count;
}

//t_menu=T_SUBPROG;t_sw_button=160;t_flag&=~T_BLINK;t_blink_count=0;

//------------------------------------------------------------------------------------------------------------------------
static void rc5_kod (uint8_t kom){
	//     
itoa2(syst,d_rc5_but,9);
itoa2(kom,d_rc5_but,14);

	if (syst>63){
		d_rc5_but[9]='_';
		d_rc5_but[10]='_';
	}

	if (kom>63){
		d_rc5_but[14]='_';
		d_rc5_but[15]='_';
	}
	
}



static void setup_rc5 (uint8_t set){
	
	upr=rc5.upr_bit;
	lcd_set_address(0,0);
	lcd_puts_p( (prog_int8_t *)&d_rc5_1[lg] );
	lcd_set_address(0,1);
	lcd_puts_p( (prog_int8_t *)&d_rc5_2[lg] );
	d_rc5_but[6]=' ';
	uint8_t count=0, temp=0,update=100;
	
	if(set){
		while(t_menu){
			count = plus_minus(count, 8);	
			
			keyboard();
			
			
			if(rc5.data_ok)	{
				if(upr!=rc5.upr_bit){
					update=100;
					if(syst!=rc5.system) d_rc5_but[6]='!';
						else{
							d_rc5_but[6]=' ';
							if (count == 0){ kom_plus	=rc5.komanda;}
							if (count == 1){ kom_minus	=rc5.komanda;}
							if (count == 2){ kom_input	=rc5.komanda;}
							if (count == 3){ kom_input1=rc5.komanda;}
							if (count == 4){ kom_input2=rc5.komanda;}
							if (count == 5){ kom_mute	=rc5.komanda;}
							if (count == 6){ kom_set	=rc5.komanda;}
							if (count == 7){ kom_menu	=rc5.komanda;}
							if (count == 8){ kom_power	=rc5.komanda;}
						}
					syst=rc5.system;
					rc5.data_ok=0;
					upr=rc5.upr_bit;
				}
			}
			
			if (rc5.error){
				rc5.error=0;
				d_rc5_but[14]='e';
				d_rc5_but[15]='r';
				lcd_set_address(0,1);
				lcd_wr_str(d_rc5_but);
			}
			
			if ( count != update){
				
				if (count == 0) temp=kom_plus;
				if (count == 1) temp=kom_minus;
				if (count == 2) temp=kom_input;
				if (count == 3) temp=kom_input1;
				if (count == 4) temp=kom_input2;
				if (count == 5) temp=kom_mute;
				if (count == 6) temp=kom_set;
				if (count == 7) temp=kom_menu;
				if (count == 8) temp=kom_power;
				
				update=count;
				rc5_kod(temp);
				temp=count*5;
				uint8_t i;
				for (i=0;i<5;i++){ d_rc5_but[i]=rcbut[temp+i];}
				lcd_set_address(0,1);
				lcd_wr_str(d_rc5_but);
			}
			
			lcd_blink(d_rc5_but,14,2);
			
			if (BF_SET){
				if(BF_LONG) {syst=EEPROM_READ(70);return;}
				
				EEPROM_write(0,kom_plus);
				EEPROM_write(1,kom_minus);
				EEPROM_write(2,kom_input);
				EEPROM_write(3,kom_mute);
				EEPROM_write(4,kom_set);
				EEPROM_write(5,kom_menu);
				EEPROM_write(6,kom_power);
				EEPROM_write(7,kom_input1);
				EEPROM_write(8,kom_input2);
				EEPROM_write(70,syst);
				b_flag=0;
				return;
			}
//			if(BF_LONG) {if(BF_POWER) break;}
		}
	}

}




//................................................................................ 				
static void gain_amplifer (uint8_t set)
{	lcd_set_address(0,0);
	lcd_puts_p( (prog_int8_t *)&gain_db_1[lg] );
	uint8_t count,update=100;
	count = k_usil;	
	while (t_menu)
	{	keyboard();
		RC5();
		count = plus_minus(count,31);
		if ( count != update)
			{	
				itoa2(count*2,gain_db_2,12);
				gain_db_2 [28]=gain_db_2 [12];
				gain_db_2 [29] = gain_db_2 [13];
				
				lcd_set_address(0,1);
				lcd_wr_str(gain_db_2+lg);
				update = count;
			}
		
		if(!set) return;			//     
		regim=2;
		lcd_blink(gain_db_2+lg,12,2);
		if  (BF_SET)
			{	if(BF_LONG) {return;}
				k_usil = count;					
				EEPROM_write (9,k_usil);
				b_flag=0;
				return;
			}
	//	if(BF_LONG) {if(BF_POWER) break;}
	}
}



//------------- ---------------
void encoder_st (uint8_t set,uint8_t n)//3.9
{	
	lcd_set_address(0,0);
	lcd_puts_p( (prog_int8_t *)&step_enc[lg] );
	
	uint8_t count,i,update=100;	

	if(!n) count=step_encoder_vol;
	else count=step_encoder_menu;
	
	while (t_menu)
	{
		keyboard();
		RC5();
		
		count = plus_minus(count,9);
		if (count != update)
		{	lcd_set_address(0,1);
			i=count+48;
			if(!n){
				step_vol[15]=step_vol[31]=i;
				lcd_wr_str(step_vol+lg);
			}
			else {
				step_menu[15]=step_menu[31]=i;
				lcd_wr_str(step_menu+lg);
			}
			
			update = count;
			
		}
		
		if(!set) return;			//     
		regim=2;
		if(!n) lcd_blink(step_vol+lg,15,1);
		else lcd_blink(step_menu+lg,15,1);
		
		if (BF_SET)
		{	if(BF_LONG) {return;}
			
			if(!n) {step_encoder_vol=count;EEPROM_write (16,step_encoder_vol);}
			else {step_encoder_menu=count;EEPROM_write (17,step_encoder_menu);}
			b_flag=0;
			return;
		}
	//	if(BF_LONG) {if(BF_POWER) break;}
	}
}



//------------- ---------------
static void encoder_adrg (uint8_t set)//3.2%
{	
	lcd_set_address(0,0);
	lcd_puts_p( (prog_int8_t *)&anti_enc[lg] );
	
	uint8_t count, update=100;	
	count=adrg_encoder;
	
	while (t_menu)
	{
		keyboard();
		RC5();

		count = plus_minus(count,19);
		if (count != update)
		{	uint8_t d,e;
			d=count/10+48;
			e=count%10+48;
			anti_value[10]=anti_value[26]=d;
			anti_value[12]=anti_value[28]=e;
			
			lcd_set_address(0,1);
			lcd_wr_str(anti_value+lg);
			update = count;
			
		}

		if(!set) return;			//     
		regim=2;
		lcd_blink(anti_value+lg,10,4);
		
		if (BF_SET)
		{	if(BF_LONG) {return;}
			
			adrg_encoder=count;
			EEPROM_write (18,adrg_encoder);
			b_flag=0;
			return;
		}
	}
}







//-----------------  -----------------------	
void rele_power (uint8_t set, uint8_t n)//4.5%
{	lcd_set_address(0,0);
	lcd_puts_p( (prog_int8_t *)&rele[lg] );
	uint8_t count,update=100;
	if(!n) count = pusk;
	else count = pusk2;
	while (t_menu)
	{	keyboard();
		RC5();
		
		count = plus_minus(count,19);
		if ( count != update)
			{	update = count;
				count*=5;
				uint8_t i,k;
				i=48+count/10;
				k=48+count%10;
				if(!n){
					rele2[12] = rele2[28] = i;
					rele2[14] = rele2[30] = k;
				}
				else {
					rele3[12] = rele3[28] = i;
					rele3[14] = rele3[30] = k;
				}
				count=update;
				lcd_set_address(0,1);
				if(!n) lcd_wr_str(rele2+lg);
				else lcd_wr_str(rele3+lg);
			}
			
		if(!set) return;
		regim=2;	
		if(!n) lcd_blink(rele2+lg,12,3);
		else lcd_blink(rele3+lg,12,3);
		if (BF_SET) 
		{	if(BF_LONG) {return;}
			if(!n) {pusk = count;EEPROM_write (11,pusk);}
			else {pusk2 = count;EEPROM_write (15,pusk2);}
			b_flag=0;
			return;
		}
	}
}


static void language_select (uint8_t set)
{	lcd_set_address(0,0);
	lcd_puts_p( (prog_int8_t *)&language[lg] );
	uint8_t count,temp,update=100;
	
	temp=lg;
	if(temp) count=1;
	else count=0;
	
	while (t_menu)
	{
		keyboard();
		RC5();
	//	if(set) count = plus_minus(count,1);
		count = plus_minus(count,1);
		if ( count != update)
			{	if (count==0) {temp=0;}	//
				else {temp=16;}	
				update=count;
				lcd_set_address(0,1);
				lcd_wr_str(language1+temp);
			}
		
		if(!set) return;			//     
		
		lcd_blink(language1+temp,0,16);
		
		if  (BF_SET)
			{	if(BF_LONG) {return;}
				lg=temp;
				EEPROM_write (12,lg);
				b_flag=0;
				return;
			}
//		if(BF_LONG) {if(BF_POWER) break;}
	}
}


static void start_vol (uint8_t set)
{	lcd_set_address(0,0);
	lcd_puts_p( (prog_int8_t *)&vl_start[lg] );
	uint8_t count,temp,update=100;
	count = start_volume;	

	while (t_menu)
	{	keyboard();
		RC5();
		
		count = plus_minus(count,31);
		if ( count != update)
			{	temp = count*2;
				temp=62-temp;
				itoa2(temp,vl_start2,12);
				vl_start2 [28] =vl_start2 [12];
				vl_start2 [29] =vl_start2 [13];
				
				lcd_set_address(0,1);
				lcd_wr_str(vl_start2+lg);
				update = count;
			}
		
		if(!set) return;			//     
		regim=2;
		lcd_blink(vl_start2+lg,11,3);
		if  (BF_SET)
			{	if(BF_LONG) {return;}
				start_volume = count;					
				EEPROM_write (19,start_volume);
				b_flag=0;
				return;
			}
	}
}


static void start_mod (uint8_t set)
{	lcd_set_address(0,0);
	lcd_wr_str(vl_mod1+lg);
	uint8_t count, update=100;
	count = start_mode;	

	while (t_menu)
	{	keyboard();
		RC5();
	//	if (set) count = plus_minus(count,1);
		count = plus_minus(count,1);
		if ( count != update)
			{	if(count) {
					vl_mod2 [13]=' ';
					vl_mod2 [14]=227;//
					vl_mod2 [15]=97;//
					
					vl_mod2 [29]='y';
					vl_mod2 [30]='e';//
					vl_mod2 [31]='s';//
				}
				else {
					vl_mod2 [13]=189;//
					vl_mod2 [14]=101;//
					vl_mod2 [15]=191;//
					
					vl_mod2 [29]=' ';
					vl_mod2 [30]='n';
					vl_mod2 [31]='o';
				}
				lcd_set_address(0,1);
				lcd_wr_str(vl_mod2+lg);
				update = count;
			}
		
		if(!set) return;			//     
		
		lcd_blink(vl_mod2+lg,13,3);
		
		if  (BF_SET)
			{	if(BF_LONG) {return;}
				start_mode = count;					
				EEPROM_write (20,start_mode);
				b_flag=0;
				return;
			}
		
	}
}


//------------- ---------------
static void vol_adrg (uint8_t set)//3.2%
{	
	lcd_set_address(0,0);
	lcd_puts_p( (prog_int8_t *)&anti_enc[lg] );
	
	uint8_t count,update=100;	
	count=adrg_click;
	while (t_menu)
	{
		keyboard();
		RC5();

		count = plus_minus(count,49);
		if (count != update){
			update=count*2;
			
			anti_clic[11]=anti_clic[27]=48+(update/10);
			anti_clic[13]=anti_clic[29]=48+(update%10);
			lcd_set_address(0,1);
			lcd_wr_str(anti_clic+lg);
			update = count;
		}

		if(!set) return;			//     
		regim=2;
		lcd_blink(anti_clic+lg,11,3);
		
		if (BF_SET)
		{	if(BF_LONG) {return;}
			
			adrg_click=count;
			EEPROM_write (21,adrg_click);
			b_flag=0;
			return;
		}
	//	if(BF_LONG) {if(BF_POWER) break;}
	}
}


void set_parametr (uint8_t count, uint8_t set){
	if (count == 0) setup_rc5(set);
	if (count == 1) gain_amplifer(set);
	if (count == 2) rele_power(set,0);
	if (count == 3) rele_power(set,1);
	if (count == 4) start_vol(set);
	if (count == 5) start_mod(set);
	if (count == 6) encoder_st(set,0);
	if (count == 7) encoder_st(set,1);
	if (count == 8) encoder_adrg(set);
	if (count == 9) vol_adrg(set);
	if (count == 10) language_select(set);
}

//-------------------------------SETUP--------------------------------------
void setup (void){
	regim=1;
	step_enc_upr=1;
	lcd_instructions_set(0x01);_delay_ms(1.6);
	lcd_set_address(0,0);
	lcd_puts_p( (prog_int8_t *)&d_set_1);

	antidrebezg(255);
	while(TF_ADRG);
	while(!BUTTON_SET);
	uint8_t count=0;
	uint8_t update=100;
	rc5.data_ok=0;
	b_flag=0;
	t_menu=T_SUBPROG;
	while(t_menu){
		count = plus_minus(count, 10);
		RC5();
		if(!count) b_flag&=~B_SET;
		keyboard();
		
		if ( count != update){
			update=100;
			set_parametr(count,0);
			update=count;
			regim=1;
		}
		
		if (BF_SET){
			if(BF_LONG) {b_flag=0;break;}
			b_flag=0;
			update=100;
			set_parametr(count,1);
			
			update=100;
			regim=1;
		}
		
		if(BF_LONG) {b_flag=0;break;}
	}
	t_menu=T_OCNREG;
	regim=0;
//	step_enc_upr=0;
}





//**********************  *********************


void t_delay_rele (void)
{	uint8_t n,c=0;
	n=100;
	while (t_menu)
	{		
		if(t_menu!=n) {
			c++;
			if(c<14) sfst[c+3]=0xFF;
			n=t_menu;
			lcd_set_address(0,1);
			lcd_wr_str(sfst);
		}
		
	}
}


static void clear_sf (void){
	uint8_t i;
	for (i=12; i!=0; i--){
		sfst[16-i]=' ';
	}
}

static void soft_start (void)
{	if(!(pusk||pusk2)){RELE2_ON;regim=0;disp_update();t_menu=T_OCNREG;return;}
	ur=31;
	regim=10;
	lcd_set_address(0,0);
	lcd_puts_p( (prog_int8_t *)&soft_d[0] );
	clear_sf();
	sfst[0]='S';
	sfst[1]='F';
	PIN_MUTE_ON;
	RELE1_ON;
	t_menu=pusk;		//  2  1.3c
	t_delay_rele();
	RELE2_ON;
	_delay_ms(100);
	RELE1_OFF;
	clear_sf();
	sfst[0]='A';
	sfst[1]='C';
	t_menu=pusk2;		
	t_delay_rele();
	PIN_MUTE_OFF;
	regim=0;
	t_menu=T_OCNREG;
}	


void off_pit (void){
	lcd_instructions_set(0x01);_delay_ms(1.6);
	lcd_set_address(0,0);
	lcd_puts_p( (prog_int8_t *)&d_power[lg] );

}


void power_off (void){

	off_pit();
	mute=0;
	PIN_MUTE_OFF;
	if(regim!=20) RELE1_ON;
	_delay_ms(50);
	RELE2_OFF;
	_delay_ms(50);
	RELE1_OFF;
	out_rele(0);
	regim=0;
	while (!BUTTON_SET);
	b_flag=0;
	while (1){
		keyboard();
		if (BF_LONG && BF_SET) break;
		
		if(rc5.data_ok){
			if(upr!=rc5.upr_bit){
				if(syst==rc5.system){
					if (rc5.komanda==kom_power) break;	
					if (rc5.komanda==kom_menu) b_flag=B_SET;
				}
			}
		}
		if (BF_SET) {b_flag=0;t_menu=T_SUBPROG;setup();off_pit();while (!BUTTON_SET);}
		
		sleep();
		
	}
	
	old_vol=64;
	if(!start_mode) current_vol=start_volume;
	soft_start();
	upr=rc5.upr_bit;
//	while (!BUTTON_SET);
	b_flag=0;
}


//--------------BUTTON---------------------------
void keyboard (void){	//194byit	
	static uint8_t temp,double_click;

	if(!BUTTON_SET){ 
		t_menu=T_OCNREG;
		if(!(TF_ADRG || duration_press)) {duration_press=1;temp=0;antidrebezg (T_B_ANDR);}		//     
			
		if (!TF_ADRG){	
			duration_press++;
			if(double_click==2) double_click=10;
			else double_click=1;
			
			t_flag|=T_TIM_CLICK;
			temp=B_SET;
		//	t_menu++;
			
			if(duration_press>6){b_flag=temp;b_flag|=B_LONG;temp=0;duration_press=0;}//t_menu=T_SUBPROG;}
			antidrebezg(80);//(T_BUTTON);
		}
	}

	else{
		if(!TF_TIM_CLICK){
			uint8_t fl=0;
			
			if (temp){
				fl=temp;
				if(double_click==10) fl|=B_DB_CLICK;
				temp=0;
			}
			if(enc_flag==1){ fl|=B_PLUS;enc_flag=0;}
			if(enc_flag==2){ fl|=B_MINUS;enc_flag=0;}
			if(fl) b_flag=fl;
			double_click=0;
		}
		duration_press=0;
		if(double_click==1) double_click=2;
	}
}	
//----------------END---------------------



static void mt (void){
	if (mute < 1) out_volume(1);
	else { out_volume(0); antidrebezg (T_MUT_DELAY); while (TF_ADRG);}
}

void change_input (uint8_t n){
	if(n!=3){
		if(!n) {if(N_input) N_input--;else N_input=2; }
		else {if(N_input<2) N_input++; else N_input=0;}
	}
	lcd_set_address(0,0);	
	if(mute) {mute=0;out_volume (1);}
	else out_volume(0);
	EEPROM_write(13,N_input);
}


void process_button (void){
	void out_p (void){
		b_flag=0;
		disp_update();
		while(!BUTTON_SET);
		t_menu=T_OCNREG;
	}
	if(BF_INPUT) {change_input(3);out_p();return;}
	if(BF_SET){
		if(b_flag==B_SET) {mt();out_p();return;}
		if(BF_DB_CLICK) {setup();out_p();return;}
		if(BF_PLUS) {change_input(0);out_p();return;}
		if(BF_MINUS) {change_input(1);out_p();return;}
		if(BF_DISP){
			if(!mute){
				vizualD^=_BV(0);
				EEPROM_write(14,vizualD);
			}
			out_p();
		}
		if(BF_LONG) {power_off();out_p();return;}
		
	}
	else {	
		if(BF_PLUS) {if(current_vol<31) current_vol++;b_flag=0;return;}
		if(BF_MINUS) {if(current_vol) current_vol--;b_flag=0;}
	}
}
//-----------------END------------------------

	
void RC5 (void){
	if(rc5.data_ok)	{
		rc5.data_ok=0;
		if(syst==rc5.system){
			
			if(!regim){
				t_menu=T_OCNREG;
				if (rc5.komanda==kom_minus){if(current_vol) current_vol--;disp_update();out_volume(0);return;}// 
				if (rc5.komanda==kom_plus) {if(current_vol<31) current_vol++;disp_update();out_volume(0);return;}// 
			}
			else t_menu=T_SUBPROG;
			
			if(rc5.komanda!=kom_set) if(regim==2) upr=100;
			if (upr!=rc5.upr_bit) {
				uint8_t temp=0;
				if (rc5.komanda==kom_plus) temp=B_PLUS;
				if (rc5.komanda==kom_minus) temp=B_MINUS;
				
				if (rc5.komanda==kom_input) { N_input=2;temp=B_INPUT;}
				if (rc5.komanda==kom_input1) {N_input=1;temp=B_INPUT;}
				if (rc5.komanda==kom_input2) {N_input=0;temp=B_INPUT;}
				
				if (rc5.komanda==kom_mute) temp=B_SET;
				if (rc5.komanda==kom_set) {temp=B_SET; if(!regim) temp|=B_DISP; }
				if (rc5.komanda==kom_menu) {temp=B_SET;if(regim) {if(regim!=10) temp|=B_LONG;}temp|=B_DB_CLICK;t_menu=T_SUBPROG;}
				if (rc5.komanda==kom_power) {temp=B_SET;temp|=B_LONG;}
				upr=rc5.upr_bit;
				b_flag=temp;
			}
		}
	}
}
	






void sleep (void){
if (!t_menu)
		{	LED_SLEEP_OFF;
			pl=0;ms=0;
			if(start_mode){
				if(begin_vol!=current_vol){
					
					EEPROM_write(100+eep_z,0xFF);
					eep_z++;
					if(eep_z>100) eep_z=0;
					EEPROM_write(100+eep_z,current_vol);
					begin_vol=current_vol;
				}
				while(EECR & (1<<EEPE));
			}
			
			EICRA &=~_BV(ISC10);
			EICRA &=~_BV(ISC11);
			EIMSK = _BV(INT0)|_BV(INT1);						//  
			SMCR |= _BV(SE);						// 
			asm("sleep");
			LED_SLEEP;
			SMCR &=~(1<<SE);		//off sleep
			t_menu=T_OCNREG;	
		}
}




int main(void)
{	
	SMCR |= 1<<SM1;											//  
	
	
//	TIMSK |= _BV(OCIE1A)|_BV(OCIE2)|_BV(TOIE0);//_BV(TICIE1)|	//TIMER1_COMPA_vect	| TIMER1_CAPT_vect	|	TIMER2_COMP_vect | 	TIMER0_OVF_vect
	
	TIMSK0 |= _BV(TOIE0);
	TIMSK1 |= _BV(OCIE1A);
	TIMSK2 |= _BV(OCIE2A);
	
	TCCR0B |= ((1<<CS01)|(1<<CS00));							//64 *31 = 0.5s
	TCCR2B |= 1<<CS21;											//8 .00204_-.002_(     )
	OCR2A=250;//250;												//1M/8=125000	1/125000=0.000008=*250=0.002c

	TCCR1B= _BV(CS10);								//  |    
	OCR1A=FAULT_TIME_RC5;										//RC5_T*17

	DDRB=INIT_DDRB;
	DDRC=INIT_DDRC;
	DDRD=INIT_DDRD;
	
	PORTB=VALUE_PORTB;
	PORTC=VALUE_PORTC;
	PORTD=VALUE_PORTD;
	
	
	//(00- ) (10- ) (11- )
	//0	 
	EICRA |=_BV(ISC01); 	//(10- )
	
	if (PIN_ENCODER) EICRA &=~_BV(ISC00);	//    -  
	else  EICRA |=_BV(ISC00); 					//  
	
	
	//1  5
	EICRA |=_BV(ISC11);		//1.0 -     1
	EIMSK = _BV(INT1)|_BV(INT0);		//  1
	
	/*
	PCICR (PCIE0 PCIE1 PCIE2)
	PCIE2	PCINT 23-16
	PCIE1	PCINT 15-8
	PCIE0	PCINT 7 -0

	PCI0	PCMSK0	PCINT0-7	//     
	PCI1	PCMSK1
	PCI2	PCMSK2

	EICRA	// 

	PCINT0_vect
	*/
	PCICR |=_BV(PCIE0)|_BV(PCIE2);
	PCMSK0|= _BV(PCINT1)|_BV(PCINT2)|_BV(PCINT3)|_BV(PCINT4)|_BV(PCINT5);
	PCMSK2|= _BV(PCINT16)|_BV(PCINT17);//|_BV(PCINT18);
	
	
	kom_plus	=EEPROM_READ(0);
	kom_minus	=EEPROM_READ(1);
	kom_input	=EEPROM_READ(2);
	kom_mute	=EEPROM_READ(3);
	kom_set		=EEPROM_READ(4);
	kom_menu	=EEPROM_READ(5);
	kom_power	=EEPROM_READ(6);
	kom_input1	=EEPROM_READ(7);
	kom_input2	=EEPROM_READ(8);
	syst=EEPROM_READ(70);
	
	k_usil=EEPROM_READ(9);

	pusk=EEPROM_READ(11);
	lg=EEPROM_READ(12);
	N_input=EEPROM_READ(13);
	vizualD=EEPROM_READ(14);
	pusk2=EEPROM_READ(15);
	step_encoder_vol=EEPROM_READ(16);
	step_encoder_menu=EEPROM_READ(17);
	adrg_encoder=EEPROM_READ(18);
	start_volume=EEPROM_READ(19);
	start_mode=EEPROM_READ(20);
	adrg_click=EEPROM_READ(21);
	
	if (k_usil>31)k_usil=0;
	if (lg) if(lg!=16) lg=16;
	if (pusk>19) pusk=4;
	if (pusk2>19) pusk2=4;
	if (vizualD>1) vizualD=0;
	if (N_input>2) N_input=0;
	if (adrg_click>49) adrg_click=4;
	
	if (step_encoder_vol>20) step_encoder_vol=0;
	if (step_encoder_menu>20) step_encoder_menu=0;
	if (adrg_encoder>19) adrg_encoder=5;
	if (start_mode>1) start_mode=0;
	if (start_volume>31) start_volume=31;
	sei();
	lcd_init();
	
	load_user_simvol(0, s_dinamik);
	load_user_simvol(8, s_point);
	load_user_simvol(16, slope_1);
	load_user_simvol(24, slope_2);
	load_user_simvol(32, slope_3);
	load_user_simvol(40, slope_4);
	load_user_simvol(48, us5);
	load_user_simvol(56, us6);//ff
	
	old_vol=32;								// 
	
	if(start_mode){
		uint8_t i;
		for (i=0;i<100;i++){
			current_vol=EEPROM_READ(100+i);
			if(current_vol<=31) {eep_z=i;begin_vol=current_vol; break;}
		}
	}
	if(current_vol>31) current_vol=0;
	
	regim=20;
	b_flag=B_SET;
	b_flag|=B_LONG;
	while (1)
	{	process_button();
		if (current_vol != old_vol) out_volume (0);
		keyboard();
		RC5();
		
		if (mute>=1){t_menu=T_SUBPROG;lcd_blink(v_level,3,8);}// 
		sleep();
	}
}

